# ----------------------------------------------------------
# CMAKE file.
# It generates the signal[.bat] command. 
# This command is the access to the Signal batch compiler.
# ----------------------------------------------------------

MK_CONFIG_NAME(${Signal_bin}/signal SIGNAL_CMD)
MK_CONFIG_NAME(sigConfig SIGCFG)
GEN_HEADER_SCRIPT(${SIGNAL_CMD})

GEN_REQUIRE_SHELL_VAR_LOADENV(${SIGNAL_CMD} Signal_bin)
GEN_REQUIRE_SHELL_VAR(${SIGNAL_CMD} SignalLib_Std)
GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin ${SIGCFG}) 
GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin "sigHelp.txt") 

GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin messignal.0) 
GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin messignal.1) 
GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin messignal.2) 
GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin messignal.3) 
GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin messignal.4) 

GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin LUSTRE.kw)
GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin SIGNAL.kw)
GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin SIGNALSME.kw)
GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin SMEKEYWORDS.kw)
ADD_EXECUTE_RIGHT(${SIGNAL_CMD})

IF(UNIX)
  FILE(APPEND ${SIGNAL_CMD} "if ( \"$#\" == 0 ) then\n")
  FILE(APPEND ${SIGNAL_CMD} "     echo \"ERROR: argument missing, use signal -h to get help\"\n")
  FILE(APPEND ${SIGNAL_CMD} "     exit -1\n")
  FILE(APPEND ${SIGNAL_CMD} "endif\n")
  FILE(APPEND ${SIGNAL_CMD} "\n")
  FILE(APPEND ${SIGNAL_CMD} "if ( \"$1\" == \"-h\" ) then\n")
  FILE(APPEND ${SIGNAL_CMD} "     more \${Signal_bin}/sigHelp.txt\n")
  FILE(APPEND ${SIGNAL_CMD} "     exit -1\n")
  FILE(APPEND ${SIGNAL_CMD} "endif\n")
  FILE(APPEND ${SIGNAL_CMD} "\n")
  FILE(APPEND ${SIGNAL_CMD} "source \${Signal_bin}/sigConfig\n")
  FILE(APPEND ${SIGNAL_CMD} "if ( \"$1\" == \"-vers\" ) then\n")
  FILE(APPEND ${SIGNAL_CMD} "     echo \"current Polychrony Signal compiler version is \${pK_VERSION}\" \"located in $Signal_bin\"\n")
  FILE(APPEND ${SIGNAL_CMD} "     exit -1\n")
  FILE(APPEND ${SIGNAL_CMD} "endif\n")
  FILE(APPEND ${SIGNAL_CMD} "\n")
  GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin "messignal.0")
  GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin "messignal.1")
  GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin "messignal.2")
  GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin "messignal.3")
  GEN_REQUIRE_FILE(${SIGNAL_CMD} Signal_bin "SIGNAL.kw"  )
#  FILE(APPEND ${SIGNAL_CMD} "date\n")
  FILE(APPEND ${SIGNAL_CMD} "\${Signal_bin}/acdc \$* \n")
  FILE(APPEND ${SIGNAL_CMD} "exit \$status\n")
#  FILE(APPEND ${SIGNAL_CMD} "date\n")
ELSE(UNIX)
  # Windows.
  FILE(APPEND ${SIGNAL_CMD} "rem %~dp0 is the path of the current file (when it runs)\n")
  FILE(APPEND ${SIGNAL_CMD} "if not \"%pK_ROOT%\" == \"\" goto lab1\n")
  FILE(APPEND ${SIGNAL_CMD} "call \"%~dp0..\\..\\PolychronyToolset_setup.bat\"\n")
  FILE(APPEND ${SIGNAL_CMD} "\n")
  FILE(APPEND ${SIGNAL_CMD} ":lab1\n")
  FILE(APPEND ${SIGNAL_CMD} "if not \"%1%\"==\"-h\" goto compile\n")
  FILE(APPEND ${SIGNAL_CMD} "   more \"%Signal_bin%\\sigHelp.txt\"\n")
  FILE(APPEND ${SIGNAL_CMD} "goto end\n")
  FILE(APPEND ${SIGNAL_CMD} "\n")
  FILE(APPEND ${SIGNAL_CMD} ":compile\n")
  FILE(APPEND ${SIGNAL_CMD} "call \"%~dp0\\sigConfig.bat\"\n")
  FILE(APPEND ${SIGNAL_CMD} "rem Slurp the command line arguments. This loop allows for an unlimited number\n")
  FILE(APPEND ${SIGNAL_CMD} "rem of arguments (up to the command line limit, anyway).\n")
  FILE(APPEND ${SIGNAL_CMD} "\n")
  FILE(APPEND ${SIGNAL_CMD} "set SIGNAL_CMD_LINE_ARGS=%1\n")
  FILE(APPEND ${SIGNAL_CMD} "if \"\"%1\"\"==\"\"\"\" goto doneStart\n")
  FILE(APPEND ${SIGNAL_CMD} "shift\n")
  FILE(APPEND ${SIGNAL_CMD} ":setupArgs\n")
  FILE(APPEND ${SIGNAL_CMD} "if \"\"%1\"\"==\"\"\"\" goto doneStart\n")
  FILE(APPEND ${SIGNAL_CMD} "set SIGNAL_CMD_LINE_ARGS=%SIGNAL_CMD_LINE_ARGS% %1\n")
  FILE(APPEND ${SIGNAL_CMD} "shift\n")
  FILE(APPEND ${SIGNAL_CMD} "goto setupArgs\n")
  FILE(APPEND ${SIGNAL_CMD} "\n")
  FILE(APPEND ${SIGNAL_CMD} ":doneStart\n")
  FILE(APPEND ${SIGNAL_CMD} "set PWD= %CD%\n")
  FILE(APPEND ${SIGNAL_CMD} "echo %SIGNAL_CMD_LINE_ARGS%\n")
  FILE(APPEND ${SIGNAL_CMD} "\"%Signal_bin%\\acdc.exe\" %SIGNAL_CMD_LINE_ARGS%\n")
  FILE(APPEND ${SIGNAL_CMD} "goto end\n")
  FILE(APPEND ${SIGNAL_CMD} ":end\n")
  FILE(APPEND ${SIGNAL_CMD} "\n")
  
  # It generates the winSignalCompil.bat file (windows only)
  MK_CONFIG_NAME(${Signal_bin}/winSignalCompil SIGNAL_CMD)
  GEN_HEADER_SCRIPT(${SIGNAL_CMD})
  FILE(APPEND ${SIGNAL_CMD} "rem \"%~dp0\" is the path of the current file (when it runs)\n")
  FILE(APPEND ${SIGNAL_CMD} "if not \"%Signal_bin%\" == \"\" goto clab \n")
  FILE(APPEND ${SIGNAL_CMD} "call \"%~dp0..\\..\\PolychronyToolset_setup.bat\" \n")
  FILE(APPEND ${SIGNAL_CMD} "\n")
  FILE(APPEND ${SIGNAL_CMD} ":clab\n")
  FILE(APPEND ${SIGNAL_CMD} "rem --- opening a window\n")
  FILE(APPEND ${SIGNAL_CMD} "start \"Signal Compiling \"  echo Infos about signal compiler : signal -h\n")
  ADD_EXECUTE_RIGHT(${SIGNAL_CMD})
ENDIF(UNIX)

