process equationSolving =
     ( ? real a;
         real b;
         real c;
       ! real x2;
         real x1;
         boolean oc;
     )
   (| (| (| OK := a/=0.0
          | OK_1 := OK
          |) where boolean OK; end
       | (| SecondDegree_ABS(a, b, c) |)/ C_y
                                        / stable
                                        / C_err
                                        / C_bb
                                        / OK
                                        / C_x21
       | (| OK := OK_1
          | FirstDegree(not OK, b, c)
          |) where boolean OK; end
       | (| a2 := x
          | err1 := err
          | a1 := x21
          | (| u := a1 default a2
             | oc := (when err1) default err2
             |)
          | x1 := u
          |) where real u, a1, a2;
                   boolean err1; end
       | a ^= b ^= c
       |)/ err2, x, err, x21, OK_1 |)
   where 
   constant real cst_epsilon = 0.0001;
   boolean err2, err, C_x, C_bb, C_err, stable, C_OK, OK, C_y, C_error, C_cc1, OK_1, C_x21;
   process FirstDegree =
        ( ? boolean Compute;
            real b;
            real c;
          ! real x;
            boolean err2;
        )
      (| (| (| (| c := cc_2
                | b := bb_1
                | (| bb := b when (b/=0.0)
                   | cc := c when (b/=0.0)
                   | x := -(cc/bb)
                   |)
                |)/ cc, bb |) where real b, c; end
          | (| c := cc_2
             | b := bb_1
             | error := (c/=0.0) when (b=0.0)
             | err2 := error
             |) where boolean error;
                      real b, c; end
          | (| (| bb := b when Compute
                | cc := c when Compute
                |)
             | bb_1 := bb
             | cc_2 := cc
             |) where real bb, cc; end
          |)/ cc_2, bb_1 |)
      where 
      real bb, cc, bb_1, cc_2;
      end
   ; 
   process SecondDegree_ABS_ =
        ( ? real a, b, c;
          ! boolean err;
            real x21, x2;
            boolean stable init true, C_y, C_bb, C_err, C_x;
        )
      pragmas 
         Grey_Box "SecondDegree"
      end pragmas
      (| (| Tick := true
          | when Tick ^= stable ^= C_y ^= C_x
          | when stable ^= a ^= b ^= c ^= C_bb
          | when C_y ^= x2
          | when C_bb ^= C_err
          | when C_err ^= err
          | when C_x ^= x21
          |)
       | (| nlabel :: (err, x21, x2, C_y, C_err, C_x) := SecondDegree_Cluster_1()
          | nlabel ^= when Tick
          |)
       | (| nlabel_266 :: SecondDegree_Cluster_2(b)
          | nlabel_266 ^= when stable
          |)
       | (| nlabel_267 :: SecondDegree_Cluster_3(c)
          | nlabel_267 ^= when stable
          |)
       | (| nlabel_268 :: C_bb := SecondDegree_Cluster_4(a)
          | nlabel_268 ^= when Tick
          |)
       | (| nlabel_291 :: stable := SecondDegree_Cluster_delays()
          | nlabel_291 ^= when Tick
          |)
       | (| nlabel_266 --> nlabel
          | b --> nlabel_266
          | nlabel_267 --> nlabel
          | c --> nlabel_267
          | nlabel_268 --> nlabel_267
          | nlabel_268 --> nlabel_266
          | nlabel_268 --> nlabel
          | a --> nlabel_268
          | nlabel_268 --> nlabel_291
          | nlabel_267 --> nlabel_291
          | nlabel_266 --> nlabel_291
          | nlabel --> nlabel_291
          |)
       |)
      where 
      boolean Tick;
      label nlabel, nlabel_266, nlabel_267, nlabel_268, nlabel_291; 
      action SecondDegree_Cluster_1 =
           ( ! boolean err;
               real x21;
               real x2;
               boolean C_y;
               boolean C_err;
               boolean C_x;
           )
         pragmas 
            Black_Box ""
         end pragmas
      
      ; 
      action SecondDegree_Cluster_2 =
           ( ? real b;
           )
         pragmas 
            Black_Box ""
         end pragmas
      
      ; 
      action SecondDegree_Cluster_3 =
           ( ? real c;
           )
         pragmas 
            Black_Box ""
         end pragmas
      
      ; 
      action SecondDegree_Cluster_4 =
           ( ? real a;
             ! boolean C_bb;
           )
         pragmas 
            Black_Box ""
         end pragmas
      
      ; 
      action SecondDegree_Cluster_delays =
           ( ! boolean stable init true;
           )
         pragmas 
            DelayCluster ""
            Black_Box ""
         end pragmas
      
      ; 
      end
   ; 
   process SecondDegree_ABS =
        ( ? real a, b, c;
          ! boolean err;
            real x21, x2;
            boolean stable, C_bb, OK, C_err, C_x21;
        )
      pragmas 
         GreyBox "SecondDegree"
      end pragmas
      (| (| Tick_357 := true
          | when Tick_357 ^= stable ^= C_bb ^= C_x21
          | when stable ^= a ^= b ^= c ^= OK
          | when C_bb ^= x2
          | when OK ^= C_err
          | when C_err ^= err
          | when C_x21 ^= x21
          |)
       | (| nlabel :: (err, x21, x2, C_bb, C_err, C_x21) := SecondDegree_Cluster_1()
          | nlabel ^= when Tick_357
          |)
       | (| nlabel_359 :: SecondDegree_Cluster_2(c)
          | nlabel_359 ^= when stable
          |)
       | (| nlabel_360 :: SecondDegree_Cluster_3(b)
          | nlabel_360 ^= when stable
          |)
       | (| nlabel_361 :: OK := SecondDegree_Cluster_4(a)
          | nlabel_361 ^= when Tick_357
          |)
       | (| nlabel_384 :: stable := SecondDegree_Cluster_delays()
          | nlabel_384 ^= when Tick_357
          |)
       | (| c --> nlabel
          | b --> nlabel
          | a --> nlabel
          | nlabel_359 --> nlabel_360
          | nlabel_359 --> nlabel
          | c --> nlabel_359
          | a --> nlabel_359
          | nlabel_360 --> nlabel
          | b --> nlabel_360
          | a --> nlabel_360
          | nlabel_361 --> nlabel_360
          | nlabel_361 --> nlabel_359
          | nlabel_361 --> nlabel
          | c --> nlabel_361
          | a --> nlabel_361
          | nlabel_361 --> nlabel_384
          | nlabel_360 --> nlabel_384
          | nlabel_359 --> nlabel_384
          | nlabel --> nlabel_384
          |)
       |)
      where 
      boolean Tick_357;
      label nlabel, nlabel_359, nlabel_360, nlabel_361, nlabel_384; 
      action SecondDegree_Cluster_1 =
           ( ! boolean err;
               real x21;
               real x2;
               boolean C_bb;
               boolean C_err;
               boolean C_x21;
           )
         pragmas 
            DefinedClockHierarchy
            Cluster {a,b,c}
            BlackBox ""
         end pragmas
         external "C"
      ; 
      action SecondDegree_Cluster_2 =
           ( ? real c;
           )
         pragmas 
            DefinedClockHierarchy
            Cluster {a,c}
            BlackBox ""
         end pragmas
         external "C"
      ; 
      action SecondDegree_Cluster_3 =
           ( ? real b;
           )
         pragmas 
            DefinedClockHierarchy
            Cluster {a,b}
            BlackBox ""
         end pragmas
         external "C"
      ; 
      action SecondDegree_Cluster_4 =
           ( ? real a;
             ! boolean OK;
           )
         pragmas 
            DefinedClockHierarchy
            Cluster {a}
            BlackBox ""
         end pragmas
         external "C"
      ; 
      action SecondDegree_Cluster_delays =
           ( ! boolean stable init true;
           )
         pragmas 
            DelayCluster
            Cluster
            BlackBox ""
         end pragmas
         external "C"
      ; 
      end
   ; 
   real x21, x;
   end
; 
