process VERIF_TABLE =
     ( ? event REACT_CLOCK;
         event SENSOR_TOP;
         event SENSOR_BOTTOM;
         real CURRENT_POS;
       ! boolean ERROR_UPWARD_TOP;
         boolean ERROR_DOWNWARD_BOTTOM;
         V_STOP;
         V_START_DOWN;
         V_START_UP;
         READY_UNLOAD;
         READY_LOAD;
         H_STOP;
         GO_TO_FEED;
         GO_TO_ROBOT;
     )
   (| (| (| H := REACT_CLOCK
          | TABLE{0.0,45.0,0.0}
          |) where event H; end
       | ENVIRONMENT{}
       | (| V_UPWARD := V_START_UP
          | V_DOWNWARD := V_START_DOWN
          | PROP_TABLE_VERT{}
          |) where V_DOWNWARD, V_UPWARD; end
       |)/ TABLE_EMPTY, TABLE_LOADED, TOP, BOTTOM |)
   where 
   process PROP_TABLE_VERT =
        ( ? event BOTTOM;
            event V_DOWNWARD;
            event V_STOP;
            event V_UPWARD;
            event TOP;
            event REACT_CLOCK;
          ! boolean ERROR_DOWNWARD_BOTTOM;
            boolean ERROR_UPWARD_TOP;
        )
      (| (| (| ENDING_EVT := ENDING_EVT_1
             | STARTING_EVT := V_DOWNWARD
             | LIMITING_EVT := BOTTOM
             | PROP_GENERIC{}
             | ERROR_DOWNWARD_BOTTOM := ERROR
             |) where event LIMITING_EVT, STARTING_EVT;
                      boolean ERROR;
                      ENDING_EVT; end
          | (| ENDING_EVT := ENDING_EVT_2
             | LIMITING_EVT := TOP
             | STARTING_EVT := V_UPWARD
             | PROP_GENERIC{}
             | ERROR_UPWARD_TOP := ERROR
             |) where event STARTING_EVT, LIMITING_EVT;
                      boolean ERROR;
                      ENDING_EVT; end
          | (| ENDING_EVT := V_UPWARD default V_STOP
             | ENDING_EVT_1 := ENDING_EVT
             |) where ENDING_EVT; end
          | (| ENDING_EVT := V_DOWNWARD default V_STOP
             | ENDING_EVT_2 := ENDING_EVT
             |) where ENDING_EVT; end
          |)/ ENDING_EVT_2, ENDING_EVT_1 |)
      where 
      process PROP_GENERIC =
           ( ? event REACT_CLOCK;
               event LIMITING_EVT;
               event ENDING_EVT;
               event STARTING_EVT;
             ! boolean ERROR;
           )
         (| (| AFT_LIMIT := LIMIT_REACHED$1
             | WITHIN := STARTED$1
             | ERROR := AFT_LIMIT and WITHIN
             | REACT_CLOCK ^= WITHIN ^= ERROR ^= AFT_LIMIT
             | LIMIT_REACHED := LIMITING_EVT default (not REACT_CLOCK)
             | STARTED := STARTING_EVT default (not ENDING_EVT) default WITHIN
             |)/ LIMIT_REACHED, STARTED, WITHIN, AFT_LIMIT |)
         where 
         boolean LIMIT_REACHED, STARTED, WITHIN init false, AFT_LIMIT init false;
         end
      ; 
      ENDING_EVT_1, ENDING_EVT, ENDING_EVT_2;
      end
   ; 
   process ENVIRONMENT =
        ( ? event H_STOP;
            event SENSOR_BOTTOM;
            event SENSOR_TOP;
            event REACT_CLOCK;
          ! event BOTTOM;
            event TOP;
            event TABLE_LOADED;
            event TABLE_EMPTY;
        )
      (| (| (| SENSOR_TOP when SENSOR_BOTTOM ^= when (not SENSOR_BOTTOM)
             | Z_S_TOP ^= Z_S_BOTTOM ^= REACT_CLOCK
             |)
          | (| S_TOP := ((not SENSOR_BOTTOM) when Z_S_TOP) default (SENSOR_TOP when Z_S_BOTTOM) default Z_S_TOP
             | Z_S_TOP := S_TOP$1
             |)
          | (| S_BOTTOM := ((not SENSOR_TOP) when Z_S_BOTTOM) default (SENSOR_BOTTOM when Z_S_TOP) default Z_S_BOTTOM
             | Z_S_BOTTOM := S_BOTTOM$1
             |)
          | (| TOP := when (S_TOP when (not Z_S_TOP))
             | BOTTOM := when (S_BOTTOM when (not Z_S_BOTTOM))
             |)
          | (| TABLE_LOADED := BOTTOM
             | TABLE_EMPTY := TOP
             |)
          |)/ S_TOP, Z_S_TOP, S_BOTTOM, Z_S_BOTTOM |)
      where 
      boolean S_TOP, S_BOTTOM, Z_S_TOP init false, Z_S_BOTTOM init true;
      process FLIP_FLOP =
           ( ! boolean STATE;
           )
         (| VNEXT := not STATE
          | STATE := VNEXT$1
          |)
         where 
         boolean VNEXT;
         end
      ; 
      end
   ; 
   process TABLE =
        { real MIN_POS, MAX_POS, INI_POS; }
        ( ? event BOTTOM;
            event TABLE_EMPTY;
            real CURRENT_POS;
            event H;
            event TOP;
            event TABLE_LOADED;
          ! event GO_TO_FEED;
            event V_START_DOWN;
            event READY_LOAD;
            event H_STOP;
            event V_STOP;
            event GO_TO_ROBOT;
            event V_START_UP;
            event READY_UNLOAD;
        )
      (| (| (| OK_GO := TABLE_EMPTY
             | OK_POS := BOTTOM
             | R_TO_F_MOVING{MIN_POS,INI_POS}
             | READY_LOAD := DEPOSIT_ACCEPT
             | H_STOP_1 := H_STOP
             | V_STOP_2 := V_STOP
             |) where event OK_POS, OK_GO, DEPOSIT_ACCEPT, H_STOP, V_STOP; end
          | (| OK_GO := TABLE_LOADED
             | OK_POS := TOP
             | F_TO_R_MOVING{MAX_POS,INI_POS}
             | READY_UNLOAD := ACCEPT_PICK_UP
             | H_STOP_3 := H_STOP
             | V_STOP_4 := V_STOP
             |) where event OK_POS, OK_GO, ACCEPT_PICK_UP, H_STOP, V_STOP; end
          | (| VST2 := V_STOP_4
             | HST2 := H_STOP_3
             | VST1 := V_STOP_2
             | HST1 := H_STOP_1
             | (| H_STOP := HST1 default HST2
                | V_STOP := VST1 default VST2
                |)
             |) where event HST1, VST1, HST2, VST2; end
          |)/ V_STOP_4, H_STOP_3, V_STOP_2, H_STOP_1 |)
      where 
      process R_TO_F_MOVING =
           { real MIN_POS, INI_POS; }
           ( ? event H;
               event OK_GO;
               event OK_POS;
               real CURRENT_POS;
             ! event DEPOSIT_ACCEPT;
               event GO_TO_FEED;
               event V_START_DOWN;
               event V_STOP;
               event H_STOP;
           )
         (| GO_TO_FEED := OK_GO
          | DEPOSIT_ACCEPT := CONTROL_ACTION(V_STOP,H_STOP)
          | V_START_DOWN := GO_TO_FEED
          | H_STOP := when ((CURRENT_POS<=MIN_POS) and (LAST_POS>MIN_POS))
          | LAST_POS := CURRENT_POS$1
          | V_STOP := OK_POS
          |)
         where 
         real LAST_POS init INI_POS;
         end
      ; 
      process F_TO_R_MOVING =
           { real MAX_POS, INI_POS; }
           ( ? event H;
               event OK_GO;
               event OK_POS;
               real CURRENT_POS;
             ! event GO_TO_ROBOT;
               event V_START_UP;
               event H_STOP;
               event V_STOP;
               event ACCEPT_PICK_UP;
           )
         (| GO_TO_ROBOT := OK_GO
          | ACCEPT_PICK_UP := CONTROL_ACTION(V_STOP,H_STOP)
          | V_START_UP := GO_TO_ROBOT
          | H_STOP := when ((CURRENT_POS>=MAX_POS) and (LAST_POS<MAX_POS))
          | LAST_POS := CURRENT_POS$1
          | V_STOP := OK_POS
          |)
         where 
         real LAST_POS init INI_POS;
         end
      ; 
      process CONTROL_ACTION =
           ( ? event ACTUATOR_READY;
               event SUPPORT_READY;
             ! event DO_IT;
           )
         (| READY := STATUS(ACTUATOR_READY,DO_IT)
          | POSSIBL := STATUS(SUPPORT_READY,DO_IT)
          | DO_IT := (ACTUATOR_READY when (SUPPORT_READY default POSSIBL)) default (SUPPORT_READY when READY)
          | ACTUATOR_READY default SUPPORT_READY ^= READY ^= POSSIBL
          |)
         where 
         event READY_UP, ON;
         boolean READY init false, POSSIBL init false;
         process STATUS =
              ( ? event ON, OFF;
                ! boolean STATE;
              )
            (| NEXT_STATE := (not OFF) default ON default STATE
             | STATE := NEXT_STATE$1
             |)
            where 
            boolean NEXT_STATE;
            end
         ; 
         end
      ; 
      process SHIFT_EVT =
           ( ? event EVT, H;
             ! event OUT;
           )
         (| NSTATES := EVT default (not H)
          | STATES := NSTATES$1
          | OUT := when STATES
          |)
         where 
         boolean NSTATES, STATES init false;
         end
      ; 
      event H_STOP_1, V_STOP_2, H_STOP_3, V_STOP_4;
      end
   ; 
   BOTTOM, TOP, TABLE_LOADED, TABLE_EMPTY;
   end
; 
