#include<stdio.h>
#include<X11/StringDefs.h>
#include<X11/Intrinsic.h>
#include<X11/cursorfont.h>
#include<Xm/MainW.h>
#include<Xm/Form.h>
#include<Xm/DrawingA.h>
#include<Xm/Label.h>
#include<Xm/PushB.h>
#include<Xm/Scale.h>

#include <Xm/Xm.h>
#include <Xm/CascadeB.h>

#include "VTSEGMENT_types.h"
#include "VTSEGMENT_body.h"

static void canvas_creat (Widget widget);
static void proc_off ();
static void proc_up ();
static void proc_down ();
static void proc_automatic ();
static void proc_inputsignalclock ();
static void proc_oversamplingclock ();

static void proc_drawingallxsamples (Widget widget, XtPointer client_data, XtPointer call_data);
static void proc_modelsorders (Widget widget, XtPointer client_data, XtPointer call_data);
static void proc_backwardprocess (Widget widget, XtPointer client_data, XtPointer call_data);

/* Declarations for X-Windows 
   ------------------------------*/

XtAppContext app_context;
Widget toplevel, canvas_widget;
Window canvas_fenetre;
Display *canvas_ecran;
GC dgc, ldgc, dgceff;
XGCValues values;
Font fonte16, fonte10;


/* Declarations des variables utilisees pour les sondes
   pour le passage de SVTSE a SAFFICHAGE.
   Cela correspond a la simulation de la compilation separee
   ----------------------------------------------------*/

/* Declarations liees aux boutons automatic et echantillonparechantillon 
   ainsi que boutons up et down
   --------------------------------------------------------------------- */
static boolean automatic, unpasentree, unpassurech;
static boolean hup, hdown;
static boolean vh;
static int xsamples, order, backward;

static boolean
iter (boolean * vh)
{
  boolean b;
  if (automatic || unpasentree || unpassurech)
    {
      b = VTSEGMENT_step ();
      (*vh) = b;
      if (b)
	AFFICHAGE_step ();
      return (!b);
    }
  return FALSE;
}

#include "mkwindows.c"

#include "interface.c"
#include "bibli.c"

static void
canvas_creat (Widget widget)
  /****************************************/
{
  canvas_widget = widget;
}

static void
proc_off ()
  /****************************************/
{
  VTSEGMENT_CloseIO ();
  exit (0);
}

static void
proc_up ()
  /****************************************/
{
  hup = TRUE;
}

static void
proc_down ()
  /****************************************/
{
  hdown = TRUE;
}

static void
proc_automatic ()
  /****************************************/
{
  unpasentree = FALSE;
  unpassurech = FALSE;
  automatic = !automatic;
}

static void
proc_inputsignalclock ()
  /****************************************/
{
  unpasentree = TRUE;
}

static void
proc_oversamplingclock ()
  /****************************************/
{
  unpassurech = TRUE;
}

static void
appli_initialize ()
{
  automatic = FALSE;
  unpasentree = FALSE;
  unpassurech = FALSE;
  xsamples = 4;
  order = 16;
  backward = 1;
  vh = TRUE;

  VTSEGMENT_initialize ();
  AFFICHAGE_initialize ();
  VTSEGMENT_OpenIO ();
}


main ()
{
  static unsigned int argc;
  static char *argv[] = { "SEGMENTATION-IRISA" };



  /*----------------------------
   *  Creation des fenetres X
   *----------------------------*/
  MrmInitialize ();
  argc = 1;
  toplevel = XtVaAppInitialize (&app_context, "SEGMENTATION-IRISA", NULL, 0, &argc, argv, NULL, NULL);

  mk_main_window (toplevel);
  XtRealizeWidget (toplevel);

  canvas_ecran = XtDisplay (canvas_widget);
  canvas_fenetre = XtWindow (canvas_widget);
  fonte16 = XLoadFont (canvas_ecran, "8x16");
  fonte10 = XLoadFont (canvas_ecran, "6x10");

  XtVaGetValues (canvas_widget, XmNforeground, &values.foreground, XmNbackground, &values.background, NULL);
  values.font = fonte16;
  dgc = XtGetGC (canvas_widget, GCForeground | GCBackground | GCFont, &values);
  values.font = fonte10;
  ldgc = XtGetGC (canvas_widget, GCForeground | GCBackground | GCFont, &values);
  values.function = GXclear;
  dgceff = XtGetGC (canvas_widget, GCForeground | GCBackground | GCFont, &values);

  XtAppAddWorkProc (app_context, (void *) iter, &vh);
  appli_initialize ();
  XtAppMainLoop (app_context);
}




static void
proc_drawingallxsamples (Widget widget, XtPointer client_data, XtPointer call_data)
{
  long int menuitem;

  if (call_data != NULL)
    {
      menuitem = (long int) client_data;
      if (menuitem == 0)
	xsamples = 1;
      else if (menuitem == 1)
	xsamples = 4;
      else if (menuitem == 2)
	xsamples = 8;
    }
}


static void
proc_modelsorders (Widget widget, XtPointer client_data, XtPointer call_data)
{
  long int menuitem;

  if (call_data != NULL)
    {
      menuitem = (long int) client_data;
      if (menuitem == 0)
	order = 2;
      else if (menuitem == 1)
	order = 16;
    }
}

static void
proc_backwardprocess (Widget widget, XtPointer client_data, XtPointer call_data)
{
  long int menuitem;

  if (call_data != NULL)
    {
      menuitem = (long int) client_data;
      if (menuitem == 0)
	backward = 1;
      else if (menuitem == 1)
	backward = 0;
    }
}
