/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include <pthread.h>

#define pK_type_task  \
  pthread_t
  
#define pK_tasks_dcl_array(N) \
  pthread_t threadsTable[N];

#define pK_io_tasks_dcl_array(N) \
  pthread_t io_threadsTable[N];

#define pK_io_Task_create(numTask, nameTask) \
  if ((pthread_create( &io_threadsTable[numTask], NULL, nameTask, NULL))) \
    printf("IO Thread creation failed: %d\n", numTask);


#define pK_Task_create(numTask, nameTask) \
  if ((pthread_create( &threadsTable[numTask], NULL, nameTask, NULL)))	\
    printf("Thread creation failed: %d\n", numTask);

#define pK_Task_exit(c) \
  pthread_exit(NULL);

#define pK_Task_cancel(numTask, nameTask) \
  pthread_cancel(threadsTable[numTask]);

  

#define pK_join(numTask) \
  if (pthread_join(threadsTable[numTask], NULL)) printf("pthread_join  failed: %d\n", numTask); 

#define pK_wait_end(numTask) pK_join(numTask)

#define pK_decl_Task(idTask) \
  static void* idTask(void* void_)

#define ___XXX_PK_XXX___ 0

#define pK_trace(idTask) \
  if (___XXX_PK_XXX___) printf("In thread : %s\n", idTask);


#define pK_Task_resume(numTask, nameTask) 

#define pK_Task_suspend(numTask, nameTask)
