module AADL_EVENTPORT =

use FIFOS_LIB;


% At Frozen_time_event, frozen current elements of in_fifo to frozen_fifo, 
  the thread can access the frozen_fifo each time when a dequeue action is performed, 
  dequeue_number is constraint in the property %
process InEventPort_Behavior =
  { integer size, dequeue_number; 
    string port_name;}
  (? boolean write_flow;
     event Frozen_time_event;
   ! boolean read_flow;)
  (| (out1, cnt1) := fifo{boolean, size, false}(when write_flow)
   | cnt1 ^= write_flow ^+ out1 
   | out1 ^= Frozen_time_event
   | read_flow := ((cnt1 cell ^read_flow) >0) when ^read_flow
   |)

  where
  integer cnt1;
  boolean out1;
end;


% The output is queued, and sent out at Output_time_event %
process OutEventPort_Behavior =
  { integer size; 
    string port_name;
  }
  (?  boolean write_flow;  
     event Output_time_event;
   !  boolean sent_flow;)

  (| (out1, cnt1) := fifo{boolean, size, false}(when write_flow)
   | cnt1 ^= write_flow ^+ out1 
   | out1 ^= Output_time_event
   | sent_flow := ((cnt1 cell ^Output_time_event) >0) when Output_time_event
   |)  where    boolean out1;    integer cnt1;  end ;
end;
