module INTERVALS=

process INTER_IN_IN=
  (? event START, FINISH, S;
   ! boolean IN_INTERVAL; )
     pragmas
       Comment "@input START: start event of intervals"
               "@input FINISH: end event of intervals"
               "@input S: event whose presence is tested in intervals"
               "@output IN_INTERVAL: true when S is in [START,FINISH], false when S is not in [START,FINISH]"
     end pragmas
  (| MEM ^= START ^+ FINISH ^+ S
   | MEM := START default not FINISH default ZMEM
   | ZMEM := MEM$ init false
   | IN_INTERVAL := (FINISH default MEM) when S
   |)
  where
    boolean MEM, ZMEM;
  end;
    
    
process INTER_IN_OUT=
  (? event START, FINISH, S;
   ! boolean IN_INTERVAL; )
     pragmas
       Comment "@input START: start event of intervals"
               "@input FINISH: end event of intervals"
               "@input S: event whose presence is tested in intervals"
               "@output IN_INTERVAL: true when S is in [START,FINISH[, false when S is not in [START,FINISH["
     end pragmas
     
  (| MEM ^= START ^+ FINISH ^+ S
   | MEM := START default not FINISH default ZMEM
   | ZMEM := MEM$ init false
   | IN_INTERVAL := MEM when S
   |)
  where
    boolean MEM, ZMEM;
  end;
    
    
process INTER_OUT_IN=
  (? event START, FINISH, S;
   ! boolean IN_INTERVAL; )
     pragmas
       Comment "@input START: start event of intervals"
               "@input FINISH: end event of intervals"
               "@input S: event whose presence is tested in intervals"
               "@output IN_INTERVAL: true when S is in ]START,FINISH], false when S is not in ]START,FINISH]"
     end pragmas
     
  (| MEM ^= START ^+ FINISH ^+ S
   | MEM := START default not FINISH default ZMEM
   | ZMEM := MEM$ init false
   | IN_INTERVAL := ZMEM when S
   |)
  where
    boolean MEM, ZMEM;
  end;
    
    
process INTER_OUT_OUT=
  (? event START, FINISH, S;
   ! boolean IN_INTERVAL; )
     pragmas
       Comment "@input START: start event of intervals"
               "@input FINISH: end event of intervals"
               "@input S: event whose presence is tested in intervals"
               "@output IN_INTERVAL: true when S is in ]START,FINISH[, false when S is not in ]START,FINISH["
     end pragmas
     
  (| MEM ^= START ^+ FINISH ^+ S
   | MEM := START default not FINISH default ZMEM
   | ZMEM := (MEM$ init false)
   | IN_INTERVAL := (not START default MEM) when S
   |)
  where
    boolean MEM, ZMEM;
  end;
    
  end;
